<template>
  <div class="treewrapper" >
    <div :class="[isView?'treeview-content':'scroll','view-content',]"
    >
      <span class="tree-dept-select">
        <div class="dept-tree" v-for="(item, index) in arrNodes" :key="index">
          <comm_tree
            :isTreeView="isTreeView"
            :props="props"
            :load="loadNode"
            :viewId="view.id" 
            :innerType = "view.innerType"
            node-key="key"
            :node="item"
            :isView="isView"
            :mutil="mutil"
            :selectOne="selectOne"
            :newTreeRadioVal = "newTreeRadioVal"
            ref="deptTree" 
            lazy
            show-checkbox
            v-bind="$attrs"
            v-on="$listeners"
            @event="changeRadioId"
            @action="getCheckVal"
            @treeViewAction="treeViewSelectId"
            @jumpToForm="jumpToFormPage"
          ></comm_tree>
        </div>
        <div class="view-nodata" v-if="isDisplay">
          <div class="view-nodata-img">
            <img src="../assets/images/empty.png" />
          </div>
          <div class="view-nodata-text">{{$t('noData')}}</div>
        </div>
      </span>
    </div>
  </div>
  
</template>

<script>
// import { Indicator } from "mint-ui";
import comm_tree from "@/components/comm_tree.vue";
import { Indicator } from 'mint-ui';

export default {
  name: "view_treeview",
  props: [
    "view",
    "isView",
    "mutil",
    "selectOne",
    "searchViewData",
    "parentId",
    "openParams"
    ],
  components: { comm_tree},
  data: function() {
    return {
      props: {
        label: "label",
        children: "zones",
        isLeaf: "leaf"
      },
      isTreeView:true,
      arrNodes:[],
      treeViewData:[],
      selectedTreeviewId:[], //当在视图选择框显示树形视图_链接视图时，选中的viewId
      selectedTreeKey:[], //当是树形视图_链接表单时，选中的key
      newTreeRadioVal:'',
      isDisplay: false
    };
  },
  computed: {
    //被选中的docs，存储docid
    selectedDocIds: {
      get: function() {
        if (this.$parent.$parent.selectedDocIds) {
          return this.$parent.$parent.selectedDocIds;
        } else {
          return [];
        }
      },
      set: function(val) {
        if (this.$parent.$parent.selectedDocIds) {
          this.$parent.$parent.selectedDocIds = val;
        } else {
          return [];
        }
      }
    },
  },
  watch:{
    arrNodes(){
      this.getDataLength();
    },
    searchViewData() {
      if(this.searchViewData.isMobile) {
        // this.getData();
        this.getTreeView(this.searchViewData);
      }
    },
  },
  created() {
    Indicator.open({
      text: this.$t('load'),
      spinnerType: 'fading-circle'
    });
    this.getTreeView();
  },

  methods: {
    jumpToFormPage(node, value) {
      if(value == 'VIEW') {
        let params = {
          linkType: "01",
          appId: this.$root.appid,
          actionContent: this.view.id,
          parentId: node.key,
          _treeviewToview: true,
          viewId: ""
        };
        this.$router.push({ name: "open", query: params });
      }else if (value == 'FORM') {
        let params = {
          linkType: "00",
          appId: this.$root.appid,
          actionContent: node.formId,
          _select: node.key,
          viewId: ""
        };
        this.$router.push({ name: "open", query: params });
      }else if (value == 'LINK') {
        let params = {
          linkType: "01",
          appId: this.$root.appid,
          actionContent: this.view.linkViewId,
          parentId: '',
          _treeviewToview: true,
          viewId: "",
          treedocid: node.key
        };
        this.$router.push({ name: "open", query: params });
      }
    },

    treeViewSelectId(val, selected) {
      if(selected == "YES") {
        this.selectedTreeKey.push(val);
      }else if(selected == "NO") {
        for(let i=0; i<this.selectedTreeKey.length; i++) {
          if(val == this.selectedTreeKey[i]) {
            this.selectedTreeKey.splice(i, 1);
            i--
          }
        }
      }
      this.$emit("getTreeviewId", this.selectedTreeKey);
    },

    changeRadioId(id) {
      this.newTreeRadioVal = id;
      let row = [];
      for(let i=0; i<this.treeViewData.length; i++) {
        if(this.newTreeRadioVal == this.treeViewData[i].id){
          row.push(this.treeViewData[i]);
        }
      }

      let params = {
        linkType: "00",
        appId: this.$root.appid,
        actionContent: this.treeViewData[0].formId,
        _select: this.newTreeRadioVal,
        viewId: this.view.id
      };

      let arrId = [];
      arrId.push(this.newTreeRadioVal);
      this.$emit("updateViewData", params, row, arrId);
      // if(this.$parent.$parent.$parent.checkboxVal) { //直接调用组件o_view_dialog的方法
      //   this.$parent.$parent.$parent.checkboxVal(params, row, arrId);
      // }else if(this.$parent.checkboxVal){
      //   this.$parent.checkboxVal(this.newTreeRadioVal);
      // }

    },

    getCheckVal(val, selected) {
      if(selected == "YES") {
        this.selectedTreeviewId.push(val);
      }else if(selected == "NO") {
        for(let i=0; i<this.selectedTreeviewId.length; i++) {
          if(val == this.selectedTreeviewId[i]) {
            this.selectedTreeviewId.splice(i, 1);
            i--
          }
        }
      }

      let selectid = '';
      let row = [];
      for(let j=0; j<this.selectedTreeviewId.length; j++) {
        selectid += this.selectedTreeviewId[j] + ';' 
        for(let y=0; y<this.treeViewData.length; y++) {
          if(this.selectedTreeviewId[j] == this.treeViewData[y].id){
            row.push(this.treeViewData[y]);
          }
        }
      }

      let params = {
        linkType: "00",
        appId: this.$root.appid,
        actionContent: this.treeViewData[0].formId,
        _select: selectid,
        viewId: this.view.id
      };
      
      // if(this.$parent.$parent.$parent.checkboxVal) { //直接调用组件o_view_dialog的方法
      //   this.$parent.$parent.$parent.checkboxVal(params, row, this.selectedTreeviewId);
      // }else if(this.$parent.$parent.checkboxVal){
      //   debugger
      //   this.$parent.$parent.checkboxVal(params, row, this.selectedTreeviewId);
      // }
      this.$emit("updateViewData", params, row, this.selectedTreeviewId);
      //this.$emit("upRocket"); //此方法可直接调用o_view_dialog中的reciveRocket()方法，需有view_delegate中的v-on="$listeners"才有作用，多级组件之间可用
    }, 

    getTreeView(searchData) {
      let op = this.openParams;
      console.log("params-->",this.openParams)
      let name = searchData?searchData.searchWord:'';
      this.$api.getTreeViewData(
        this.$root.appid,
        this.view.id,
        {
          parentId: "",
          parentDocId: op.parentId
        },
        {},
        name,
        {
          onSucess: response => {
            Indicator.close();
            let viewData = response.data;
            this.treeViewData = response.data.data.data;
            if (viewData.data.data && viewData.data.data.length > 0) {
              let nodes = [];
              this.view.columns.forEach(clm => {
                if (clm.mappingField == "name_Node") {
                  viewData.data.data.forEach(doc => {
                    let label = doc.items[clm.id].value;
                    nodes.push({ key: doc.id, level: 0, label: label, children: doc.children, formId: doc.formId});
                  });
                }
              });
              this.arrNodes = nodes
            }else if(viewData.data.data.length == 0){
              this.isDisplay = true;
            }
          }
        }
      );
    },

    getDataLength(){
      this.$emit("data",this.arrNodes)
    },

    doSearch(){},
    
    loadNode(node, resolve) {
      this.$api.getTreeViewData(
        this.$root.appid,
        this.view.id,
        {
          parentId: node.key
        },
        {},
        "",
        {
          onSucess: response => {
            let viewData = response.data;
            this.treeViewData = this.treeViewData.concat(response.data.data.data)
            if (viewData.data.data && viewData.data.data.length > 0) {
              let nodes = [];
              this.view.columns.forEach(clm => {
                if (clm.mappingField == "name_Node") {
                  viewData.data.data.forEach(doc => {
                    let label = doc.items[clm.id].value;
                    nodes.push({ key: doc.id, label: label, children: doc.children, formId: doc.formId});
                  });
                }
              });
              resolve(nodes);
              this.$forceUpdate();
            }
          }
        }
      );
    }
  }
};
</script>

<style lang="scss">

</style>